package jp.marunomaruno.judeapi2cpp;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.InvalidPropertiesFormatException;
import java.util.List;
import java.util.Properties;

/**
 * JudeApi2Cpp AvP[ṼvpeBێNXłB
 * ̃NX̃CX^X͂ЂƂ܂B
 * ̃NX̃RXgN^găCX^X𐶐邱Ƃ͂ł܂B
 * CX^X̎擾ɂ́AgetInstance\bh𗘗pĂB
 * 
 * @author maruno
 * @version 1.0, 2007-12-20
 * @since 1.0
 */
public class JudeApi2CppProperty {

	public static final String PROPERTY_MAKEFILE_LIBS = "makefile.libs";

	public static final String PROPERTY_MAKEFILE_INCLUDES = "makefile.includes";

	public static final String PROPERTY_MAKEFILE_LDFLAGS = "makefile.ldflags";

	public static final String PROPERTY_MAKEFILE_CFLAGGS = "makefile.cflaggs";

	public static final String PROPERTY_MAKEFILE_CC = "makefile.cc";

	public static final String PROPERTY_MAKEFILE_OBJECT_SUFFIX = "makefile.object.suffix";

	public static final String PROPERTY_DESTINATION_FORCE_REPLACE_FILE = "destination.force.replace.file";

	public static final String PROPERTY_DESTINATION_DIRECTORY_DELETE_FILES = "destination.directory.delete.files";

	public static final String PROPERTY_AUTO_SHUTDOWN = "auto.shutdown";

	public static final String PROPERTY_DEFAULT_INCLUDE = "default.include";

	public static final String PROPERTY_TYPES_EXCEPT = "types.except";

	public static final String PROPERTY_SOURCE_FILE = "source.file";

	public static final String PROPERTY_DESTINATION_DIRECTORY = "destination.directory";

	public static final String PROPERTY_MAKEFILE_PATH = "makefile.path";

	public static final String PROPERTY_USER_DIR = "user.dir";

	public static final String PROPERTY_MAKEFILE_TARGET = "makefile.target";

	public static final String PROPERTY_DEBUG = "debug";

	public static final String PROPERTY_CREATE_GETTER = "creategetter";

	public static final String PROPERTY_CREATE_SETTER = "createsetter";

	public static final String PROPERTY_USE_PHISICAL_NAME = "use.phisical.name";

	public static final String PROPERTY_CREATE_CONSTRACTOR = "createconstractor";

	/**
	 * ̃NX̗B̃CX^XłB
	 */
	private static JudeApi2CppProperty instance = null;

	/**
	 * ̃VXe GUI AvP[Vǂ܂B
	 */
	private boolean guiApplication;

	/**
	 * ̃VXeŎgpvpeBIuWFNgłB
	 */
	private Properties properties;

	/**
	 * ϊJudẽvWFNgt@CłB
	 */
	private String sourceFile;
	/**
	 * ϊCPP\[X邠ĐfBNg[łB
	 */
	private String destinationDirectory;
	
	/**
	 * MakefilẽXPg\[X܂B
	 */
	private String makefileSekeleton;

	/**
	 * ړĨvO
	 */
	private String target;

	/**
	 * ̃VXẽfobO[hłBtruȅꍇAWo͂ɃNX̏o͂܂B
	 */
	private boolean debug = false;

	/**
	 * CPPt@CƂčȂ^̃XgłB
	 */
	private List<String> exceptTypes = null;

	/**
	 * ftHginclude^̃XgłB
	 */
	private List<String> defaultIncludeTypes = null;

	/**
	 * ɑ΂W̃Zb^[𐶐邩ǂ܂BtruȅꍇA܂B
	 */
	private boolean createSetter;
	
	/**
	 * ɑ΂W̃Qb^[𐶐邩ǂ܂BtruȅꍇA܂B
	 */
	private boolean createGetter;
	
	/**
	 * RXgN^[EfXgN^[𐶐邩ǂ܂BtruȅꍇA܂B
	 */
	private boolean createConstractor;
	
	/**
	 * Vbg_Eɖ⍇邩ǂ܂BtruȅꍇA⍇s܂B
	 */
	private boolean autoShutdown;
	
	/**
	 * CPP̂ĐfBNg[ɂ邷ׂĂ̊t@CϊOɍ폜邩ǂ܂BtruêƂ폜܂B
	 */
	private boolean deleteFiles;
	
	/**
	 * t@CIɒu邩ǂ܂BtruêƂAIɍ폜܂B
	 * Adestination.directory.delete.files l true ̂Ƃ́A̒l͈Ӗ܂B
	 */
	private boolean forceReplaceFile;

	/**
	 *      gă\[X𐶐邩ǂłBtruȅꍇAg܂B
	 *      A̎w肪Ȃ΁Aw肳Ă閼Ô܂܎g܂B
	 *      ͒`̒̂̎wɂ܂B
	 *           	@phisical-name 
	 *      ÄɂẮA̒`̒ŁȀԂɕLq܂B
	 *           	@phisical-parameter-name 1 2 ...
	 */
	private boolean usePhisicalName;

	/**
	 * MakefileŁAIuWFNgW[gqłB
	 */
	private  String objectSuffix;

	/*
	 * Makefile̕ϐłB
	 */
	/**
	 * RpC[
	 */
	private  String cc;
	/**
	 * RpCIvV
	 */
	private  String cflags;
	/**
	 * NIvV
	 */
	private  String ldflags;
	/**
	 * wb_[t@C̃pX
	 */
	private  String includes;
	/**
	 * sCũpX
	 */
	private  String libs;

	/**
	 * ̃NX̃RXgN^łB̃NX͎gȂ悤ɂȂĂ̂ŁA
	 * ̃NX̃CX^X́AgetInstance\bhgĎ擾܂B
	 */
	private JudeApi2CppProperty() {
		try {
			properties = loadProperties();
		} catch (Exception e) {
			e.printStackTrace();
		}
		initialize();
	}

	@SuppressWarnings("unchecked")
	private void initialize() {
//		for (Enumeration<String> e = (Enumeration<String>) properties.propertyNames(); e.hasMoreElements(); ) {
//			String name = e.nextElement();
//			properties.setProperty(name, properties.getProperty(name));
//		}
		
		sourceFile = properties.getProperty(PROPERTY_SOURCE_FILE, "");
		if (sourceFile.equals("")) {
			setSourceFile(System.getProperty(PROPERTY_USER_DIR));
		}

		destinationDirectory = properties.getProperty(PROPERTY_DESTINATION_DIRECTORY, "");
		if (destinationDirectory.equals("")) {
			setDestinationDirectory(System.getProperty(PROPERTY_USER_DIR));
		}

		makefileSekeleton = properties.getProperty(PROPERTY_MAKEFILE_PATH, "");
		if (makefileSekeleton.equals("")) {
			setMakefileSekeleton(System.getProperty(PROPERTY_USER_DIR) + File.separator + "makefile.sekeleton");
		}

		target = properties.getProperty(PROPERTY_MAKEFILE_TARGET, "");
//		properties.setProperty("makefile.target", properties.getProperty("makefile.target"));

		debug = Boolean.parseBoolean(properties.getProperty(PROPERTY_DEBUG, "false"));

		usePhisicalName = Boolean.parseBoolean(properties.getProperty(PROPERTY_USE_PHISICAL_NAME, "true"));
//		if (usePhisicalName) {
//			setUsePhisicalName(Boolean.getBoolean(System.getProperty(PROPERTY_USE_PHISICAL_NAME)));
//		}


		createSetter = Boolean.parseBoolean(properties.getProperty(PROPERTY_CREATE_SETTER, "false"));
		createGetter = Boolean.parseBoolean(properties.getProperty(PROPERTY_CREATE_GETTER, "false"));

		createConstractor = Boolean.parseBoolean(properties.getProperty(PROPERTY_CREATE_CONSTRACTOR, "false"));
		
		try {
			exceptTypes = Arrays.asList(properties.getProperty(PROPERTY_TYPES_EXCEPT).split(","));
			for (int i = 0; i < exceptTypes.size(); i++) {
				exceptTypes.set(i, exceptTypes.get(i).trim());
			}
		} catch (RuntimeException e) {
			exceptTypes = new ArrayList<String>();
		}
		
		try {
			defaultIncludeTypes = Arrays.asList(properties.getProperty(PROPERTY_DEFAULT_INCLUDE).split(","));
			for (int i = 0; i < defaultIncludeTypes.size(); i++) {
				defaultIncludeTypes.set(i, defaultIncludeTypes.get(i).trim());
			}
		} catch (RuntimeException e) {
			defaultIncludeTypes = new ArrayList<String>();
		}
		
		autoShutdown = Boolean.parseBoolean(properties.getProperty(PROPERTY_AUTO_SHUTDOWN, "false"));
		
		deleteFiles = Boolean.parseBoolean(properties.getProperty(PROPERTY_DESTINATION_DIRECTORY_DELETE_FILES, "true"));

		forceReplaceFile = Boolean.parseBoolean(properties.getProperty(PROPERTY_DESTINATION_FORCE_REPLACE_FILE, "false"));

		objectSuffix = properties.getProperty(PROPERTY_MAKEFILE_OBJECT_SUFFIX, "o");

		cc = properties.getProperty(PROPERTY_MAKEFILE_CC, "gcc");
		cflags = properties.getProperty(PROPERTY_MAKEFILE_CFLAGGS, "");
		ldflags = properties.getProperty(PROPERTY_MAKEFILE_LDFLAGS, "");
		includes = properties.getProperty(PROPERTY_MAKEFILE_INCLUDES, "");
		libs = properties.getProperty(PROPERTY_MAKEFILE_LIBS, "");
	}
	
	/**
	 * ̃NX̗B̃CX^X擾܂B
	 * @return ̃NX̗B̃CX^XB
	 */
	public static JudeApi2CppProperty getInstance() {
		if (instance == null) {
			instance = new JudeApi2CppProperty();
		}
		return instance;
	}

	/**
	 * ̃VXẽvpeB擾܂B
	 * @return ̃VXẽvpeB
	 * @throws IOException
	 */
	public  Properties loadProperties() throws IOException {

		Properties defaultProperties = new Properties();
		try {
			defaultProperties.loadFromXML(new FileInputStream("defaultproperties.xml"));
		} catch (InvalidPropertiesFormatException e) {
			throw e;
		} catch (FileNotFoundException e) {
			throw e;
		} catch (IOException e) {
			throw e;
		}

		Properties properties =  new Properties(defaultProperties);
		try {
			properties.loadFromXML(new FileInputStream("properties.xml"));
		} catch (InvalidPropertiesFormatException e) {
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}

		return properties;
	}

	/**
	 * ̃VXẽvpeBۑ܂B
	 * @throws IOException
	 */
	public  void storeProperties() throws IOException {
		properties.storeToXML(new FileOutputStream("properties.xml"), "JudeApi2Cpp̃vpeBt@C");
		
	}

	/**
	 * ϊƂJudẽvWFNgt@C擾܂B
	 * @return ϊƂJudẽvWFNgt@C
	 */
	public  String getSourceFile() {
		return sourceFile;
	}

	/**
	 * ϊƂJudẽvWFNgt@Cݒ肵܂B
	 * @param sourceFile ϊƂJudẽvWFNgt@C
	 */
	public  void setSourceFile(String sourceFile) {
		this.sourceFile = sourceFile;
		properties.setProperty(PROPERTY_SOURCE_FILE, sourceFile);
	}

	/**
	 * ϊCPP\[X邠ĐfBNg[擾܂B
	 * @return ϊCPP\[X邠ĐfBNg[
	 */
	public  String getDestinationDirectory() {
		return destinationDirectory;
	}

	/**
	 * ϊCPP\[X邠ĐfBNg[ݒ肵܂B
	 * @param destinationDirectory ϊCPP\[X邠ĐfBNg[
	 */
	public  void setDestinationDirectory(String destinationDirectory) {
		this.destinationDirectory = destinationDirectory;
		properties.setProperty(PROPERTY_DESTINATION_DIRECTORY, destinationDirectory);
	}

	/**
	 * MakefilẽXPg\[X擾܂B
	 * @return MakefilẽXPg\[X
	 */
	public  String getMakefileSekeleton() {
		return makefileSekeleton;
	}

	/**
	 * MakefilẽXPg\[Xݒ肵܂B
	 * @param makefileSekeleton MakefilẽXPg\[X
	 */
	public  void setMakefileSekeleton(String makefileSekeleton) {
		this.makefileSekeleton = makefileSekeleton;
		properties.setProperty(PROPERTY_MAKEFILE_PATH, makefileSekeleton);
	}

	/**
	 * ړĨvO擾܂B
	 * @return ړĨvO
	 */
	public  String getTarget() {
		return target;
	}

	/**
	 * ړĨvOݒ肵܂B
	 * @param target ړĨvO
	 */
	public  void setTarget(String target) {
		this.target = target;
		properties.setProperty(PROPERTY_MAKEFILE_TARGET, target);
	}

	/**
	 * ̃VXẽfobO[hłB
	 * @return Wo͂ɃNX̏o͂ꍇtrue
	 */
	public  boolean isDebug() {
		return debug;
	}

	/**
	 * CPPt@CƂčȂ^̃Xg擾܂B
	 * @return CPPt@CƂčȂ^̃Xg
	 */
	public  List<String> getExceptTypes() {
		return exceptTypes;
	}

	/**
	 * ftHginclude^̃Xg擾܂B
	 * @return ftHginclude^̃Xg
	 */
	public  List<String> getDefaultIncludeTypes() {
		return defaultIncludeTypes;
	}

	/**
	 * Vbg_Eɖ⍇邩ǂ܂B
	 * @return Vbg_Eɖ⍇ȂꍇtrueAłȂꍇfalseԂ܂B
	 */
	public  boolean isAutoShutdown() {
		return autoShutdown;
	}

	/**
	 * CPP̂ĐfBNg[ɂt@CϊOɍ폜邩ǂ擾܂B
	 * @return 폜ꍇtrue
	 */
	public  boolean isDeleteFiles() {
		return deleteFiles;
	}

	
	public boolean isCreateSetter() {
		return createSetter;
	}

	public void setCreateSetter(boolean createSetter) {
		this.createSetter = createSetter;
		properties.setProperty(PROPERTY_CREATE_SETTER, Boolean.toString(createSetter));
	}

	public boolean isCreateGetter() {
		return createGetter;
	}

	public void setCreateGetter(boolean createGetter) {
		this.createGetter = createGetter;
		properties.setProperty(PROPERTY_CREATE_GETTER, Boolean.toString(createGetter));
	}
	
	public boolean isCreateConstractor() {
		return createConstractor;
	}

	public void setCreateConstractor(boolean createConstractor) {
		this.createConstractor = createConstractor;
		properties.setProperty(PROPERTY_CREATE_CONSTRACTOR, Boolean.toString(createConstractor));
	}

	/**
	 * t@CIɒu邩ǂ擾܂B
	 * @return IɒuƂtrue
	 */
	public boolean isForceReplaceFile() {
		return forceReplaceFile;
	}

	/**
	 * t@CIɒu邩ǂ擾܂B
	 * @param forceReplaceFile IɒuƂtrue
	 */
	public  void setForceReplaceFile(boolean forceReplaceFile) {
		this.forceReplaceFile = forceReplaceFile;
		properties.setProperty(PROPERTY_DESTINATION_FORCE_REPLACE_FILE, Boolean.toString(forceReplaceFile));
	}

	/**
	 * MakefileŁAIuWFNgW[gq擾܂B
	 * @return MakefileŁAIuWFNgW[gq
	 */
	public  String getObjectSuffix() {
		return objectSuffix;
	}

	/**
	 * RpC[擾܂B
	 * @return RpC[
	 */
	public  String getCc() {
		return cc;
	}

	/**
	 * RpCIvV
	 * @return RpCIvV
	 */
	public  String getCflags() {
		return cflags;
	}

	/**
	 * wb_[t@C̃pX擾܂B
	 * @return wb_[t@C̃pX
	 */
	public  String getIncludes() {
		return includes;
	}

	/**
	 * NIvV擾܂B
	 * @return NIvV
	 */
	public  String getLdflags() {
		return ldflags;
	}

	/**
	 * sCũpX擾܂B
	 * @return sCũpX
	 */
	public  String getLibs() {
		return libs;
	}

	/**
	 * ̃VXe GUI AvP[VǂԂ܂B
	 * @return GUI AvP[V̂Ƃ true
	 */
	public boolean isGuiApplication() {
		return guiApplication;
	}

	/**
	 * ̃VXe GUI AvP[Vł邱Ƃݒ肵܂B
	 */ 
	public void setGuiApplication() {
		this.guiApplication = true;
	}

	/**
	 * ̃VXe CUI AvP[Vł邱Ƃݒ肵܂B
	 */ 
	public void setCuiApplication() {
		this.guiApplication = false;
	}

	/**
	 * ̃VXe̎vpeBׂĕWo͂ɏo͂܂B
	 */
	public void print() {
		System.out.println("GUI Application                    = " + guiApplication);
		System.out.println("source.file                        = " + sourceFile);
		System.out.println("destination.directory              = " + destinationDirectory);
		System.out.println("makefile.path                      = " + makefileSekeleton);
		System.out.println("makefile.target                    = " + target);
		System.out.println("createsetter                       = " + createSetter);
		System.out.println("creategetter                       = " + createGetter);
		System.out.println("createconstractor                  = " + createConstractor);
		System.out.println("debug                              = " + debug);
		System.out.println("use.phisical.name                  = " + usePhisicalName);
		System.out.println("types.except                       = " + exceptTypes);
		System.out.println("default.include                    = " + defaultIncludeTypes);
		System.out.println("auto.shutdown                      = " + autoShutdown);
		System.out.println("destination.directory.delete.files = " + deleteFiles);
		System.out.println("destination.force.replace.file     = " + forceReplaceFile);
		System.out.println("makefile.object.suffix             = " + objectSuffix);
		System.out.println("makefile.cc                        = " + cc);
		System.out.println("makefile.cflags                    = " + cflags);
		System.out.println("makefile.ldflags                   = " + ldflags);
		System.out.println("makefile.includes                  = " + includes);
		System.out.println("makefile.libs                      = " + libs);
	}

	public boolean isUsePhisicalName() {
		return usePhisicalName;
	}

	public void setUsePhisicalName(boolean usePhisicalName) {
		this.usePhisicalName = usePhisicalName;
		properties.setProperty(PROPERTY_USE_PHISICAL_NAME, Boolean.toString(usePhisicalName));
	}


}
