package jp.marunomaruno.judeapi2cpp;

import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getName;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getParameterNames;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getReturnTypeExpression;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getSigneture;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getTypeExpression;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getUpperCaseName;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getVisibilityString;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isConst;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isExcepted;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isExplicit;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isFriend;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isInline;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isMutable;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.isVirtual;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.parseCsvTokenFormat;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.printElementComment;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import com.change_vision.jude.api.inf.exception.ProjectLockedException;
import com.change_vision.jude.api.inf.model.IAttribute;
import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IClassifierTemplateParameter;
import com.change_vision.jude.api.inf.model.IGeneralization;
import com.change_vision.jude.api.inf.model.IModel;
import com.change_vision.jude.api.inf.model.INamedElement;
import com.change_vision.jude.api.inf.model.IOperation;
import com.change_vision.jude.api.inf.model.IPackage;
import com.change_vision.jude.api.inf.model.IParameter;
import com.change_vision.jude.api.inf.project.ProjectAccessor;
import com.change_vision.jude.api.inf.project.ProjectAccessorFactory;

/**
 * Jude ̃vWFNg̏񂩂AΉCPPt@CAwb_[t@CAMAKEt@C܂B
 * 
 * @author maruno
 * @version 1.0, 2007-12-20
 * @since 1.0
 */
public class JudeApi2Cpp {

	private static final String CSV_SEPARATER = ",";
	public static String THROWS = "@throws";

	/**
	 * ̓t@CB
	 */
	@SuppressWarnings("unused")
	private File source;

	/**
	 * o̓fBNgB
	 */
	private File destination;

	/**
	 * ^[QbgƂȂvOB
	 */
	private String target;

	/**
	 * ̃vWFNgŎgpĂNX
	 */
	private Set<IClass> classes = new HashSet<IClass>();

	/**
	 * ̃CX^X𐶐ftHgRXgN^[łB
	 */
	public JudeApi2Cpp() {
	}

	/**
	 * JudevWFNgCPP̃\[XAwb_[AMAKEFILEɕϊ܂B
	 * 
	 * @param source
	 *            Judẽt@C
	 * @param destination
	 *            ϊ̃t@Ci[fBNg[
	 * @param target ^[QbgƂȂvO
	 * @throws ProjectLockedException
	 * @throws Exception
	 * @see com.change_vision.jude.api.inf.exception.ProjectLockedException
	 */
	public void execute(File source, File destination, String target)
			throws ProjectLockedException, Exception {
		this.source = source;
		this.destination = destination;
		this.target = target;
		
		// ĐfBNgmF
		createDestinationDirectoryIfNotExists(this.destination);
		
		
		// vpeB\
		JudeApi2CppUtil.println("----------------------------------------");
		JudeApi2CppUtil.println("PROPERTIES");
		JudeApi2CppUtil.printProperties();
		JudeApi2CppUtil.println("----------------------------------------");

		// vWFNgJāAvWFNgf擾
		ProjectAccessor prjAccessor = ProjectAccessorFactory
				.getProjectAccessor();
		try {
			prjAccessor.open(source.getPath());
//		} catch (ProjectLockedException e) {	// astah* Community ł͎gȂ
//			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		}
		IModel iModel = prjAccessor.getProject();
		JudeApi2CppUtil.print(iModel, "project");
		JudeApi2CppUtil.println("----------------------------------------");

		// NX̏W
		setClassInfometion(iModel.getOwnedElements());

		// NXt@Co͂B
		for (IClass c : classes) {
			JudeApi2CppUtil.print(c);
			createHeaderFile(c); // wb_[t@C
			createCppFile(c); // cppt@C
		}

		// maket@Co͂B
		createMakefile(classes);
		
		// NX̏t@Co͂B
		createClassInfoFile(classes);

		// IbZ[W
		System.out.println("ϊI܂B");
	}

	private void createDestinationDirectoryIfNotExists(File destination) {
		if (destination.exists()) {
			return;
		}
		
		destination.mkdir();
	}

	/**
	 * vWFNg̖OtvfċAIɕ\܂B A擪 "java"  "javax" Ŏn܂pbP[W͏܂B
	 * 
	 * @param iNamedElements
	 */
	private void setClassInfometion(INamedElement[] iNamedElements) {
		for (INamedElement element : iNamedElements) {
			if (element.getName().equals("java")) continue;
			if (element.getName().equals("javax")) continue;

			// *&Ă̂́A^Ƃēo^Ȃ(̂̌^͕ʂɒ`Ă)
			if (element.getName().indexOf('*') >= 0)
				continue;
			if (element.getName().indexOf('&') >= 0)
				continue;
			if (element.getName().indexOf('<') >= 0)
				continue;

			if (element instanceof IClass && isExcepted((IClass) element)) {
				classes.add((IClass) element);
			}

			if (element instanceof IPackage) {
				setClassInfometion(((IPackage) element).getOwnedElements());
			}
		}

	}

	/**
	 * makefile쐬܂B
	 * 
	 * @param classes
	 *            NX̃Zbg
	 */
	private void createMakefile(Set<IClass> classes) {
		if (classes.size() == 0)
			return;

		PrintWriter out = createFile("Makefile");
		if (out == null) {
			return;
		}

		try {
			BufferedReader in = new BufferedReader(new FileReader(
					JudeApi2CppProperty.getInstance().getMakefileSekeleton()));

			// t@C̃Rg
			out.println("# ");
			out.println("# " + "Makefile");
			out.println("# " + "create date: "
					+ DateFormat.getDateInstance().format(new Date()));
			out.println("# ");

			String line;

			// OBJS̑O܂
			while ((line = in.readLine()) != null) {
				line = line.replaceFirst("@\\(target\\)", target);
				if (line.startsWith("OBJS"))
					break;
				out.println(line);
			}

			// OBJS ̓WJ
			out.print(line);
			for (IClass c : classes) {
				if (!getName(c).equalsIgnoreCase(target)) {
					out.print(" \\\n\t" + getName(c) + "."
							+ JudeApi2CppProperty.getInstance().getObjectSuffix());
				}
			}
			out.println();

			// cŌ܂
			while ((line = in.readLine()) != null) {
				out.println(line);
			}

			in.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.close();

	}

	/**
	 * NX̏t@C쐬܂B
	 * 
	 * @param classes
	 *            NX̃Zbg
	 */
	private void createClassInfoFile(Set<IClass> classes) {
		if (classes.size() == 0)
			return;

		PrintWriter out = createFile("classinfo.csv");
		if (out == null) {
			return;
		}

		IClass[] cs = classes.toArray(new IClass[0]);
		Arrays.sort(cs, new StereotypeAndNameComparator<IClass>());
		
		// NX̏
		out.println("XeI^Cv" + CSV_SEPARATER + "NX" + CSV_SEPARATER + "NX" + CSV_SEPARATER + "`");
		
		for (IClass c : cs) {
			out.print(parseCsvTokenFormat(Arrays.asList(c.getStereotypes()).toString()));		// XeI^Cv
			out.print(CSV_SEPARATER);

			out.print(getName(c));		// NX()
			out.print(CSV_SEPARATER);

			out.print(c.getName());		// NX
			out.print(CSV_SEPARATER);
			
			out.print(parseCsvTokenFormat(c.getDefinition()));		// `
			out.print(CSV_SEPARATER);
			
			out.println();
			
		}
		out.println();

		
		// NX̏
		out.println("XeI^Cv" + CSV_SEPARATER + "NX" + CSV_SEPARATER + "NX" + CSV_SEPARATER + "" + CSV_SEPARATER + "" + CSV_SEPARATER + "^" + CSV_SEPARATER + "^" + CSV_SEPARATER + "l" + CSV_SEPARATER + "`");
		
		for (IClass c : cs) {

			IAttribute[] attributes = c.getAttributes();
			Arrays.sort(attributes, new StereotypeAndNameComparator<IAttribute>());

			for (IAttribute attribute : attributes) {
				out.print(parseCsvTokenFormat(Arrays.asList(c.getStereotypes()).toString()));		// XeI^Cv
				out.print(CSV_SEPARATER);

				out.print(getName(c));		// NX()
				out.print(CSV_SEPARATER);

				out.print(c.getName());		// NX
				out.print(CSV_SEPARATER);
				
				out.print(getName(attribute));		// ()
				out.print(CSV_SEPARATER);
				
				out.print(attribute.getName());		// 
				out.print(CSV_SEPARATER);
				
				out.print(getTypeExpression(attribute));		// ^()
				out.print(CSV_SEPARATER);
				
				out.print(attribute.getTypeExpression());		// ^
				out.print(CSV_SEPARATER);
				
				out.print(attribute.getInitialValue());		// l
				out.print(CSV_SEPARATER);
				
				out.print(parseCsvTokenFormat(attribute.getDefinition()));		// `
				out.print(CSV_SEPARATER);
				
				out.println();
				
			}

		}
		out.println();

		// NX̏
		out.println("XeI^Cv" + CSV_SEPARATER + "NX" + CSV_SEPARATER + "NX" + CSV_SEPARATER + "앨" + CSV_SEPARATER + "얼" + CSV_SEPARATER + "߂l^" + CSV_SEPARATER + "߂l^" + CSV_SEPARATER + "` " + CSV_SEPARATER + "...");
		
		for (IClass c : cs) {

			IOperation[] operations = c.getOperations();
			Arrays.sort(operations, new StereotypeAndNameComparator<IOperation>());


			for (IOperation operation : operations) {
				out.print(parseCsvTokenFormat(Arrays.asList(c.getStereotypes()).toString()));		// XeI^Cv
				out.print(CSV_SEPARATER);

				out.print(getName(c));		// NX()
				out.print(CSV_SEPARATER);

				out.print(c.getName());		// NX
				out.print(CSV_SEPARATER);
				
				out.print(getName(operation));		// 얼()
				out.print(CSV_SEPARATER);
				
				out.print(operation.getName());		// 얼
				out.print(CSV_SEPARATER);
				
				out.print(getReturnTypeExpression(operation));		// ߂ľ^
				out.print(CSV_SEPARATER);
				
				out.print(operation.getReturnTypeExpression());		// ߂ľ^
				out.print(CSV_SEPARATER);
				
				out.print(parseCsvTokenFormat(operation.getDefinition()));		// `
				out.print(CSV_SEPARATER);
				
				for (String parameter  : getParameterNames(operation)) {
					out.print(parameter);		// 
					out.print(CSV_SEPARATER);
					
				}
				
				out.println();
				
			}

		}
		
		out.println();
		out.close();

	}

	/**
	 * NX̃wb_[t@C𐶐܂B
	 * 
	 * @param iClass
	 */
	private void createHeaderFile(IClass iClass) {
		String name = getParseTypeName(iClass);
		String headerMacroName = name.toUpperCase() + "_H_";
		PrintWriter out = createFile(name + ".h");
		if (out == null) {
			return;
		}

		// CN[hK[h
		out.println("#ifndef " + headerMacroName);
		out.println("#define " + headerMacroName);

		// t@C̃Rg
		out.println("/*");
		out.println(" * " + name + ".h");
		out.println(" * " + "create date: "
				+ DateFormat.getDateInstance().format(new Date()));
		out.println(" */");

		// w肳ꂽ^̃CN[h
		for (String type : JudeApi2CppProperty.getInstance().getDefaultIncludeTypes()) {
			out.println("#include <" + type + ">");
		}

		// gpĂ^̃CN[h
		Set<String> types = getParseTypeNames(iClass);
		for (String type : types) {
			if (type.equals(name)) {
				continue;
			}
			out.println("#include \"" + type + ".h\"");
		}

		// O std ̐錾
		out.println("using namespace std;");

		// NX錾͂
		// Rg
		out.println();
		printElementComment(out, "", iClass);
		
		// ev[g
		createTemplateDeclear(iClass, out);
		
		
		out.print("class " + name);

		IGeneralization[] generalizations = iClass.getGeneralizations();
		if (generalizations.length > 0) {
			out.print(" : ");
			boolean first = true;
			for (IGeneralization g : generalizations) {
				// J}
				if (!first) {
					out.print(", ");
				}

				// z{NX
				if (isVirtual(g)) {
					out.print(" virtual ");
				}

				// {NX̃ANZX
				out.print(" " + getVisibilityString(g) + " ");

				// {NX
				out.print(getName(g.getSuperType()));

				first = false;
			}
		}
		out.print(" {");
		out.println();

		// o[ϐ̐錾
		String indent = "    ";
		String lastVisibility = "";
		String visibility = "";
		
		for (IAttribute attribute : iClass.getAttributes()) {

			// Us\̑̓XLbv
			if (!attribute.isEnable()) continue;

			// ÔȂ̓XLbv
			if (attribute.getName() == null || attribute.getName().isEmpty())
				continue;

			// 
			visibility = JudeApi2CppUtil.getVisibility(attribute);
			if (!visibility.equals(lastVisibility)) {
				out.println(visibility + ": ");
				lastVisibility = visibility;
			}

			// Rg
			out.println();
			printElementComment(out, indent, attribute);

			out.print(indent);

			// ÓI
			if (attribute.isStatic()) {
				out.print("static ");
			}

			// 萔
			if (!attribute.isChangeable()) {
				out.print("const ");
			}

			// mutable
			if (isMutable(attribute)) {
				out.print("mutable ");
			}

			// ^ O
			out.print(getSigneture(attribute));
			
			// static const ̂Ƃ̏l
			if (attribute.isStatic() && !attribute.isChangeable()) {
				out.print(" = " + attribute.getInitialValue());
			}

			out.println(";");
		}

		// RXgN^[̐錾
		createHeaderConstractor(iClass, out);
		
		lastVisibility = "public";
		
		// o[֐̐錾
		for (IOperation operation : iClass.getOperations()) {

			// 
			visibility = JudeApi2CppUtil.getVisibility(operation);
			if (!visibility.equals(lastVisibility)) {
				out.println(visibility + ": ");
				lastVisibility = visibility;
			}
			
			//@Rg
			printElementComment(out, indent, operation);

			out.print(indent);

			// ÓI
			if (operation.isStatic()) {
				out.print("static ");
			}

			// ()z֐
			if (operation.isAbstract() || isVirtual(operation)) {
				out.print("virtual ");
			}

			// friend
			if (isFriend(operation)) {
				out.print("friend ");
			}

			// explicit֐
			if (isExplicit(operation)) {
				out.print(" explicit ");
			}
			// ߂ľ^
			out.print(getReturnTypeExpression(operation) + " ");

			// ֐
			out.print(getName(operation));
			out.print("(");

			// 
			createParameters(out, operation);

			out.print(")");

			// const֐
			if (isConst(operation)) {
				out.print(" const");
			}
			
			// throws
			createThrows(operation, out);


			// z֐
			if (operation.isAbstract()) {
				out.print(" = 0");
			}

			out.println(";");

		}

		// ANZbT[̐錾
		createHeaderAccesser(out, iClass.getAttributes(), getParseTypeName(iClass));
		
		
		// NX錾̏I
		out.println("};");

		// CN[hK[hI
		out.println("#endif");
		out.close();
	}

	/**
	 * @param iClass
	 * @param out
	 */
	private void createTemplateDeclear(IClass iClass, PrintWriter out) {
		if (iClass.getTemplateParameters().length > 0) {
			out.print("template <class ");
			
			IClassifierTemplateParameter[] parameters = iClass.getTemplateParameters();
			
			out.print(parameters[0].getName());
			for (int i = 1; i < parameters.length; i++) {
				out.print(", class ");
				out.print(parameters[i].getName());
				
			}
			out.print(">");
			out.print("\n");
				
		}
	}

	private void createThrows(IOperation operation, PrintWriter out) {
		String definition = operation.getDefinition();
		int index = definition.indexOf(THROWS);
		
		if (index < 0) {
			return;
		}

		out.print(" throw ");
		out.print("(");
		String[] tokens = definition.substring(index).split("[ \n]");
		try {
			out.print(tokens[1]);
		} catch (RuntimeException e) {
			// Ȃ
		}
		
		while ((index = definition.indexOf(THROWS, index + 1)) >= 0) {
			tokens = definition.substring(index).split("[ \n]");
			try {
				out.print(", ");
				out.print(tokens[1]);
			} catch (RuntimeException e) {
				// Ȃ
			}
		}

		out.print(") ");
		
	}

	/**
	 * @param iClass
	 * @param out
	 * @return
	 */
	private void createHeaderConstractor(IClass iClass, PrintWriter out) {

		if (!JudeApi2CppProperty.getInstance().isCreateConstractor()) {
			return;
		}

		String indent;
		out.println();
		out.print("public:");
		out.println();
		indent = "    ";

		// Rg
		out.println(indent + "/**");
		out.println(indent + " * RXgN^[");
		out.println(indent + " */");

		out.print(indent);
		out.print(getName(iClass));
		out.print("(");
		out.print(");");
		out.println();
		out.println();

		// tRXgN^[
		if (iClass.getAttributes().length > 0) {
			out.println(indent + "/**");
			out.println(indent + " * RXgN^[");
			for (IAttribute attribute : iClass.getAttributes()) {

				// Us\̑̓XLbv
				if (!attribute.isEnable()) continue;

				// ÔȂ̓XLbv
				if (attribute.getName() == null || attribute.getName().isEmpty())
					continue;

				// ÓIȒ萔̓XLbv
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				out.println(indent + " * @param " + getName(attribute) + " " + attribute.getName());
			}

			out.println(indent + " */");

			out.print(indent);
			out.print(getName(iClass));
			out.print("(");
			
			boolean firstLoop = true;
			for (IAttribute attribute : iClass.getAttributes()) {

				// Us\̑̓XLbv
				if (!attribute.isEnable()) continue;

				// ÔȂ̓XLbv
				if (attribute.getName() == null || attribute.getName().isEmpty())
					continue;

				// ÓIȒ萔̓XLbv
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				if (!firstLoop) {
					out.print(", ");
				}

				// ^ O
				out.print(getSigneture(attribute));
				
				firstLoop = false;
			}

			out.print(");");
			out.println();
			out.println();
	
		}

		// Rs[RXgN^[̐錾
		out.println(indent + "/**");
		out.println(indent + " * Rs[RXgN^[");
		out.println(indent + " */");

		out.print(indent);

		out.print(getName(iClass));
		out.print("(const ");
		out.print(getName(iClass));
		out.print("& obj");
		out.print(");");
		out.println();
		out.println();

		// fXgN^[̐錾
		out.println(indent + "/**");
		out.println(indent + " * fXgN^[");
		out.println(indent + " */");
		out.print(indent);
		out.print("virtual ~");
		out.print(getName(iClass));
		out.print("(");
		out.print(");");
		out.println();
		out.println();

		// Zq̃I[o[[h
		out.println(indent + "/**");
		out.println(indent + " * Zq");
		out.println(indent + " */");

		out.print(indent);
		out.print(getName(iClass));
		out.print("& ");
		out.print("operator=");
		out.print("(const ");
		out.print(getName(iClass));
		out.print("& obj");
		out.print(");");
		out.println();
		out.println();

		// Zq̃I[o[[h
		out.println(indent + "/**");
		out.println(indent + " * Zq");
		out.println(indent + " */");

		out.print(indent);
		out.print("bool ");
		out.print("operator==");
		out.print("(const ");
		out.print(getName(iClass));
		out.print("& obj");
		out.print(");");
		out.println();
		out.println();

}

	private void createHeaderAccesser(PrintWriter out, IAttribute[] attributes, String className) {

		if (!(JudeApi2CppProperty.getInstance().isCreateSetter() | JudeApi2CppProperty.getInstance().isCreateGetter())) {
			return;
		}
		
		String indent = "    ";
		
		out.println();
		if (attributes.length > 0) {
			out.println("public: ");
		}
		
		for (IAttribute attribute : attributes) {

			String upperCaseName = getUpperCaseName(attribute);
			if (upperCaseName.length() == 0) {
				continue;
			}

			// Zb^[
			if (JudeApi2CppProperty.getInstance().isCreateSetter()) {

				if (attribute.isChangeable()) {
					// Rg
					StringBuilder comment = new StringBuilder(attribute.getName() + " ݒ肷B");
					comment.append("\n");
					comment.append("@param " + getName(attribute) + " " + attribute.getName());
					out.println();
					printElementComment(out, indent, comment.toString());

					out.print(indent);
					// ÓI
					if (attribute.isStatic()) {
						out.print("static ");
					}
					out.print("void" + " ");
					out.print("set" + upperCaseName);
					out.print("(");
					out.print(getTypeExpression(attribute));
					
					// dx
					if (JudeApi2CppUtil.isMultiplicity(attribute)) {
						out.print("*");
					}
					out.print(" ");
					out.print(getName(attribute));
					out.print(");");
					out.println();
				}
			}
			
			if (JudeApi2CppProperty.getInstance().isCreateGetter()) {
				// Rg
				StringBuilder comment = new StringBuilder(attribute.getName() + " 擾B");
				comment.append("\n");
				comment.append("@return " + attribute.getName());
				out.println();
				printElementComment(out, indent, comment.toString());

				// Qb^[
				out.print(indent);

				out.print(getTypeExpression(attribute));
				// dx
				if (JudeApi2CppUtil.isMultiplicity(attribute)) {
					out.print("*");
				}
				out.print(" ");
				out.print("get" + upperCaseName);
				out.print("(");
				out.print(") const;");
				out.println();
				out.println();
			}
			
		}
		
	}

	/**
	 * NXcppt@C𐶐܂B
	 * 
	 * @param iClass
	 *            NX
	 */
	private void createCppFile(IClass iClass) {
		String name = getParseTypeName(iClass);
		PrintWriter out = createFile(name + ".cpp");
		if (out == null) {
			return;
		}

		// t@C̃Rg
		out.println("/*");
		out.println(" * " + name + ".cpp");
		out.println(" * " + "create date: "
				+ DateFormat.getDateInstance().format(new Date()));
		out.println(" */");

		// w肳ꂽ^̃CN[h
		for (String type : JudeApi2CppProperty.getInstance().getDefaultIncludeTypes()) {
			out.println("#include <" + type + ">");
		}

		// wb_[t@C̃CN[h
		out.println("#include \"" + name + ".h\"");

		// O std ̐錾
		out.println("using namespace std;");

		// NX錾͂
		// Rg
		out.println();
		printElementComment(out, "", iClass);

		// lĂ郁o[ϐ̐錾(`)
		String indent = "";

		for (IAttribute attribute : iClass.getAttributes()) {

			if (attribute.isStatic() && !attribute.isChangeable()
					&& attribute.getInitialValue().length() > 0) {

				// static const ̂Ƃ́Al͐ݒ肵Ȃ
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				out.println();
				printElementComment(out, indent, attribute);

				out.print(indent);

				// ÓI
				// if (attribute.isStatic()) {
				// out.print("static ");
				// }

				// 萔
				if (!attribute.isChangeable()) {
					out.print("const ");
				}

				// ^
				out.print(attribute.getTypeExpression() + " ");

				// ϐ
				out.print(name);
				
				// ev[g
				createCppTemplate(iClass, out);

				
				out.print("::");
				out.print(getName(attribute));

				// dx
				if (JudeApi2CppUtil.isMultiplicity(attribute)) {
					out.print("[]");
				}

				// l
				if (attribute.getInitialValue().length() > 0) {
					out.print(" = " + attribute.getInitialValue());
				}

				out.println(";");
			}

		}

		// RXgN^[̐錾
		createCppConstractor(iClass, name, out);

		// o[֐̐錾
		for (IOperation operation : iClass.getOperations()) {
			// z֐
			if (operation.isAbstract())
				continue;

			//@Rg
			out.println();
			printElementComment(out, indent, operation);

			out.print(indent);

			// ev[g
			createTemplateDeclear(iClass, out);
			
			// inline
			if (isInline(operation)) {
				out.print("inline ");
			}

			// ߂ľ^
			out.print(getReturnTypeExpression(operation) + " ");

			// ֐
			if (!isFriend(operation)) {
				out.print(name);
				// ev[g
				createCppTemplate(iClass, out);
				out.print("::");
			}

			out.print(getName(operation));
			out.print("(");

			// 
			createParameters(out, operation);

			out.print(")");

			// 萔
			if (isConst(operation)) {
				out.print(" const ");
			}

			// throws
			createThrows(operation, out);
			
			// `
			out.println();
			out.println("{");

			// O
			for (String condition : operation.getPreconditions()) {
				out.println("    // O");
				out.print("    ");
				out.print("assert(");
				out.print(condition);
				out.print(");");
				out.println();
			}

			out.println("    // @TODO ");

			// 
			for (String condition : operation.getPostconditions()) {
				out.println("    // ");
				out.print("    ");
				out.print("assert(");
				out.print(condition);
				out.print(");");
				out.println();
			}
			
			// RXgN^EfXgN^EvoidȊÔƂ̓ftHg̖߂l߂
			if (!(operation.getReturnTypeExpression().equals("") || operation
					.getReturnTypeExpression().equals("void"))) {
				out.print("    return ");
				out.print(getReturnDefaultValue(operation));
				out.println(";");
			}

			out.println("}");
		}

		// ANZbT[̐錾
		createCppAccesser(out, iClass.getAttributes(), name);

		out.close();
	}

	/**
	 * @param iClass
	 * @param out
	 */
	private void createCppTemplate(IClass iClass, PrintWriter out) {
		if (iClass.getTemplateParameters().length > 0) {
			out.print("<");
			
			IClassifierTemplateParameter[] parameters = iClass.getTemplateParameters();
			
			out.print(parameters[0].getName());
			for (int i = 1; i < parameters.length; i++) {
				out.print(", ");
				out.print(parameters[i].getName());
				
			}
			out.print(">");
				
		}
	}

	/**
	 * @param iClass
	 * @param name
	 * @param out
	 */
	private void createCppConstractor(IClass iClass, String name, PrintWriter out) {
		
		if (!JudeApi2CppProperty.getInstance().isCreateConstractor()) {
			return;
		}

		String indent;
		// Rg
		indent = "";
		out.println();
		out.println(indent + "/**");
		out.println(indent + " * RXgN^[");
		out.println(indent + " */");

		out.print(name);
		out.print("::");
		out.print(getName(iClass));
		out.print("(");
		out.print(")");
		out.println("{");
		out.println("    // @TODO ");
		out.print("}");
		out.println();
		out.println();

		if (iClass.getAttributes().length > 0) {
			out.println(indent + "/**");
			out.println(indent + " * RXgN^[(t)");
			for (IAttribute attribute : iClass.getAttributes()) {

				// Us\̑̓XLbv
				if (!attribute.isEnable()) continue;

				// ÔȂ̓XLbv
				if (attribute.getName() == null || attribute.getName().isEmpty())
					continue;

				// ÓIȒ萔̓XLbv
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				out.println(indent + " * @param " + getName(attribute) + " " + attribute.getName());
			}

			out.println(indent + " */");

			createTemplateDeclear(iClass, out);

			out.print(name);
			out.print("::");
			out.print(getName(iClass));
			createCppTemplate(iClass, out);
			out.print("(");
			
			boolean firstLoop = true;
			for (IAttribute attribute : iClass.getAttributes()) {

				// Us\̑̓XLbv
				if (!attribute.isEnable()) continue;

				// ÔȂ̓XLbv
				if (attribute.getName() == null || attribute.getName().isEmpty())
					continue;

				// ÓIȒ萔̓XLbv
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				if (!firstLoop) {
					out.print(", ");
				}

				// ^ O
				out.print(getSigneture(attribute));

				firstLoop = false;
			}

			out.print("):");
			out.println();
			
			out.print("    ");
			firstLoop = true;
			for (IAttribute attribute : iClass.getAttributes()) {

				// Us\̑̓XLbv
				if (!attribute.isEnable()) continue;

				// ÔȂ̓XLbv
				if (attribute.getName() == null || attribute.getName().isEmpty())
					continue;

				// ÓIȒ萔̓XLbv
				if (attribute.isStatic() && !attribute.isChangeable()) {
					continue;
				}

				if (!firstLoop) {
					out.print(", ");
				}

				// ^ O
				out.print(getName(attribute));
				out.print("(");
				out.print(getName(attribute));
				out.print(")");

				firstLoop = false;
			}
			
			out.println();
			out.println("{");
			out.println("    // @TODO ");
			out.print("}");
			out.println();
			out.println();
	
		}

		// Rs[RXgN^[̐錾
		out.println(indent + "/**");
		out.println(indent + " * Rs[RXgN^[");
		out.println(indent + " */");

		out.print(name);
		out.print("::");
		out.print(getName(iClass));
		out.print("(const ");
		out.print(getName(iClass));
		out.print("& obj");
		out.print(")");
		out.println();
		out.println("{");
		out.println("    // @TODO ");
		out.print("}");
		out.println();
		out.println();

		// fXgN^[̐錾
		out.println(indent + "/**");
		out.println(indent + " * fXgN^[");
		out.println(indent + " */");
		out.print(name);
		out.print("::");
		out.print("~");
		out.print(getName(iClass));
		out.print("(");
		out.print(")");
		out.println();
		out.println("{");
		out.println("    // @TODO ");
		out.print("}");
		out.println();
		out.println();
		
		// Zq̃I[o[[h
		out.println(indent + "/**");
		out.println(indent + " * Zq");
		out.println(indent + " */");

		out.print(getName(iClass));
		out.print("& ");
		out.print(name);
		out.print("::");
		out.print("operator=");
		out.print("(const ");
		out.print(getName(iClass));
		out.print("& obj");
		out.print(")");
		out.println();
		out.print("{");
		out.println();
		out.println("    if (this == &obj) return *this;");
		out.println("    // @TODO ");
		out.println("    return *this;");
		out.print("}");
		out.println();
		out.println();

		// Zq̃I[o[[h
		out.println(indent + "/**");
		out.println(indent + " * Zq");
		out.println(indent + " */");

		out.print("bool ");
		out.print(name);
		out.print("::");
		out.print("operator==");
		out.print("(const ");
		out.print(getName(iClass));
		out.print("& obj");
		out.print(")");
		out.println();
		out.print("{");
		out.println();
		out.println("    if (this == &obj) true;");
		out.println("    // @TODO ");
		out.println("    return false;");
		out.println();
		out.print("}");
		out.println();
		out.println();

	}

	/**
	 * @param out
	 * @param operation
	 * @since 3.0
	 */
	private void createParameters(PrintWriter out, IOperation operation) {
		if (operation.getParameters().length <= 0) {
			return;
		}
		
		String[] parameterNames = getParameterNames(operation);
		
		// ^
		out.print(getTypeExpression(operation.getParameters()[0]) + " ");
		// O
		out.print(parameterNames[0]);
		
		for (int i = 1; i < operation.getParameters().length; i++) {
			out.print(", ");
			// ^
			out.print(getTypeExpression(operation.getParameters()[i]) + " ");
			// O
			out.print(parameterNames[i]);
		}

		
	}

	private void createCppAccesser(PrintWriter out, IAttribute[] attributes, String className) {

		if (!(JudeApi2CppProperty.getInstance().isCreateSetter() | JudeApi2CppProperty.getInstance().isCreateGetter())) {
			return;
		}

		String indent = "";
		
		for (IAttribute attribute : attributes) {
			
			String upperCaseName = getUpperCaseName(attribute);
			if (upperCaseName.length() == 0) {
				continue;
			}
			
			// Zb^[
			if (JudeApi2CppProperty.getInstance().isCreateSetter()) {

				if (attribute.isChangeable()) {
					// Rg
					StringBuilder comment = new StringBuilder(attribute.getName() + " ݒ肷B");
					comment.append("\n");
					comment.append("@param " + getName(attribute) + " " + attribute.getName());
					out.println();
					printElementComment(out, indent, comment.toString());

					createTemplateDeclear((IClass) attribute.getOwner(), out);

					out.print(indent);
					out.print("void" + " ");
					out.print(className);
					createCppTemplate((IClass) attribute.getOwner(), out);
					out.print("::");
					out.print("set" + upperCaseName);
					createCppTemplate((IClass) attribute.getOwner(), out);

					out.print("(");
					out.print(getTypeExpression(attribute));
					// dx
					if (JudeApi2CppUtil.isMultiplicity(attribute)) {
						out.print("*");
					}
					out.print(" ");
					out.print(getName(attribute));
					out.print(")");
					out.println();
					out.println("{");
					out.println("    // @TODO ");
					out.println(indent
							+ "    "
							+ (attribute.isStatic() ? (className + "::")
									: "this->") + getName(attribute) + " = "
							+ getName(attribute) + ";");
					out.println("}");
					out.println();
				}
			}

			if (JudeApi2CppProperty.getInstance().isCreateGetter()) {
				// Rg
				StringBuilder comment = new StringBuilder(attribute.getName() + " 擾B");
				comment.append("\n");
				comment.append("@return " + attribute.getName());
				out.println();
				printElementComment(out, indent, comment.toString());

				// Qb^[
				createTemplateDeclear((IClass) attribute.getOwner(), out);

				out.print(indent);
				out.print(getTypeExpression(attribute));
				// dx
				if (JudeApi2CppUtil.isMultiplicity(attribute)) {
					out.print("*");
				}
				out.print(" ");
				out.print(className);
				createCppTemplate((IClass) attribute.getOwner(), out);
				out.print("::");
				out.print("get" + getUpperCaseName(attribute));
				out.print("(");
				out.print(") const");
				out.println();
				out.println("{");
				out.println("    // @TODO ");
				out.println(indent + "    " + "return " + getName(attribute)
						+ ";");
				out.println("}");
				out.println();
			}
			
		}
		
	}

	/**
	 * ֐̖߂ľ^ɑΉftHg̖߂l擾B
	 * 
	 * @param operation
	 *            
	 * @return ftHg̖߂lB
	 */
	private String getReturnDefaultValue(IOperation operation) {
		final String[][] DEFAULT_VALUE = { { "char", "0" },
				{ "signed char", "0" }, { "unsigned char", "0" },
				{ "short", "0" }, { "signed short", "0" },
				{ "unsigned short", "0U" }, { "int", "0" },
				{ "signed int", "0" }, { "unsigned int", "0U" },
				{ "long", "0L" }, { "signed long", "0L" },
				{ "unsigned long", "0UL" }, { "float", "0.0F" },
				{ "double", "0.0" }, {"bool", "false" }, };

		for (int i = 0; i < DEFAULT_VALUE.length; i++) {
			if (DEFAULT_VALUE[i][0].equals(operation.getReturnTypeExpression())) {
				// if (operation.getReturnTypeExpression().replaceAll("\u0026",
				// "").trim().equals(DEFAULT_VALUE[i][0])) {
				return DEFAULT_VALUE[i][1];
			}
		}
		return "NULL";
	}

	/**
	 * ^A|C^[QƂL擾B܂Aev[ǧ^ׂďB
	 * 
	 * @param type
	 *            NX
	 * @return NXA|C^[QƂL
	 */
	private String getParseTypeName(IClass type) {
		if (type == null)
			return null;

		String s;
		s = getName(type);
		
		s = s.replaceAll("[\u002a\u0026]", "").trim(); // [*&]
		int index = s.indexOf('<');

		return index < 0 ? s : s.substring(0, index);
	}

	/**
	 * ̃NX̒ŎgĂ^̏W擾B^̏W͈ȉ̂ƂB̒ŁAw肳ꂽO^͓ȂB E{NX Ě^
	 * E̖߂ľ^ Ë̌^
	 * 
	 * @param iClass
	 *            NX
	 * @return ̃NX̒ŎgĂ^̏W
	 */
	private Set<String> getParseTypeNames(IClass iClass) {
		if (iClass == null)
			return new HashSet<String>();

		Set<String> types = new HashSet<String>();

		// {NX
		IGeneralization[] generalizations = iClass.getGeneralizations();
		for (IGeneralization g : generalizations) {
			types.add(getParseTypeName(g.getSuperType()));
		}

		// ̌^
		for (IAttribute attribute : iClass.getAttributes()) {
			if (attribute.getName() == null || attribute.getName().isEmpty())
				continue;

			types.add(getParseTypeName(attribute.getType()));
		}

		// 
		for (IOperation operation : iClass.getOperations()) {
			// ߂ľ^
			types.add(getParseTypeName(operation.getReturnType()));

			// ̌^
			for (IParameter parameter : operation.getParameters()) {
				types.add(getParseTypeName(parameter.getType()));
			}
		}

		// O^
		types.removeAll(JudeApi2CppProperty.getInstance().getExceptTypes());
		types.remove(null);

		return types;
	}

	/**
	 * w肳ꂽt@Cɏo͂Xg[𐶐܂B
	 * 
	 * @param name
	 *            t@C
	 * @return o̓Xg[BAt@CuȂꍇ null
	 */
	private PrintWriter createFile(String name) {
		String destinationName = destination.getPath() + File.separator + name;
		try {
			File destinationFile = new File(destinationName);
			if (!JudeApi2CppProperty.getInstance().isDeleteFiles() && !JudeApi2CppProperty.getInstance().isForceReplaceFile() && destinationFile.exists()) {
				if(!JudeApi2CppUtil.delete(destinationFile)) {
					System.out.println(destinationName + " t@C͍쐬܂łB");
					return null;
				}
			}
			System.out.println(destinationName + " t@C쐬܂B");
			return new PrintWriter(destinationName);
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

}
