package jp.marunomaruno.judeapi2cpp;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.marunomaruno.judeapi2cpp.gui.JudeApi2CppGuiUtil;

import com.change_vision.jude.api.inf.model.IAssociation;
import com.change_vision.jude.api.inf.model.IAttribute;
import com.change_vision.jude.api.inf.model.IClass;
import com.change_vision.jude.api.inf.model.IConstraint;
import com.change_vision.jude.api.inf.model.IDependency;
import com.change_vision.jude.api.inf.model.IElement;
import com.change_vision.jude.api.inf.model.IGeneralization;
import com.change_vision.jude.api.inf.model.IModel;
import com.change_vision.jude.api.inf.model.IMultiplicityRange;
import com.change_vision.jude.api.inf.model.INamedElement;
import com.change_vision.jude.api.inf.model.IOperation;
import com.change_vision.jude.api.inf.model.IParameter;
import com.change_vision.jude.api.inf.model.IRealization;
import com.change_vision.jude.api.inf.model.ITaggedValue;

/**
 * Jude ̃vWFNg̏擾郆[eBeBENXłB
 * 
 * @author  maruno
 * @version 1.0, 2007-12-20
 * @since   1.0
 */
public class JudeApi2CppUtil {

	public static final String PHISICAL_NAME = "@phisical-name";


	/**
	 * NXtpXŎ擾܂B
	 * 
	 * @param iClass
	 *            NX
	 * @return NXitpXj
	 */
	public static String getFullName(IClass iClass) {
		if (iClass == null) return "";

		StringBuffer sb = new StringBuffer();
		IElement owner = iClass.getOwner();
		while (owner != null && owner instanceof INamedElement
				&& owner.getOwner() != null) {
			sb.insert(0, ((INamedElement) owner).getName() + "::");
			owner = owner.getOwner();
		}
		sb.append(iClass.getName());
		return sb.toString();
	}

	/**
	 * Otvf̖OXg擾܂B
	 * 
	 * @param iNamedElements
	 * @return OXg
	 */
	public static List<String> getNames(INamedElement[] iNamedElements) {
		if (iNamedElements == null) return new ArrayList<String>();

		List<String> names = new ArrayList<String>();
		for (int i = 0; i < iNamedElements.length; i++) {
			INamedElement element = iNamedElements[i];
			names.add(element.getName());
		}
		return names;
	}

	/**
	 * ĉ̖OXg擾܂B
	 * 
	 * @param iGeneralizations
	 * @return OXg
	 */
	public static List<List<String>> getNames(IGeneralization[] iGeneralizations) {
		if (iGeneralizations == null) return new ArrayList<List<String>>();

		List<List<String>> names = new ArrayList<List<String>>();
		for (int i = 0; i < iGeneralizations.length; i++) {
			IGeneralization generalization = iGeneralizations[i];
			List<String> m = new ArrayList<String>();
			m.add(generalization.getName());
			m.add(generalization.getSubType().getName());
			m.add(generalization.getSuperType().getName());
			names.add(m);
		}
		return names;
	}

	/**
	 * ̖OXg擾܂B
	 * 
	 * @param iRealizations
	 * @return OXg
	 */
	public static List<List<String>> getNames(IRealization[] iRealizations) {
		if (iRealizations == null) return new ArrayList<List<String>>();

		List<List<String>> names = new ArrayList<List<String>>();
		for (int i = 0; i < iRealizations.length; i++) {
			IRealization realization = iRealizations[i];
			List<String> m = new ArrayList<String>();
			m.add(realization.getName());
			m.add(realization.getSupplier().getName());
			m.add(realization.getClient().getName());
			names.add(m);
		}
		return names;
	}

	/**
	 * dx擾܂B
	 * 
	 * @param iMultiplicityRange
	 * @return dx
	 */
	public static List<String> getMultiplicity(IMultiplicityRange[] iMultiplicityRange) {
		if (iMultiplicityRange == null) return new ArrayList<String>();

		List<String> m = new ArrayList<String>();
		for (int i = 0; i < iMultiplicityRange.length; i++) {
			IMultiplicityRange range = iMultiplicityRange[i];
			String r = "[" + toMultiplicityString(range.getLower()) + ".."
					+ toMultiplicityString(range.getUpper()) + "]";
			m.add(r);
		}
		return m;
	}

	/**
	 * dx킷擾܂B
	 * 
	 * @param range
	 * @return dx킷
	 */
	public static String toMultiplicityString(int range) {
		switch (range) {
		case IMultiplicityRange.UNDEFINED:
			return "UNDEFINED";
		case IMultiplicityRange.UNLIMITED:
			return "*";
		default:
		}
		return String.valueOf(range);
	}

	/**
	 * 擾܂B
	 * 
	 * @param iParameters
	 * @return ̏񃊃Xg
	 */
	public static List<List<String>> getParameterList(IParameter[] iParameters) {
		if (iParameters == null) return new ArrayList<List<String>>();

		List<List<String>> parameters = new ArrayList<List<String>>();
		for (int i = 0; i < iParameters.length; i++) {
			IParameter parameter = iParameters[i];
			List<String> m = new ArrayList<String>();
			m.add(parameter.getName());
			m.add(parameter.getTypeExpression());
			parameters.add(m);
		}
		return parameters;
	}

	/**
	 * ˑ̖OXg擾܂B
	 * 
	 * @param iDependencies
	 * @return OXg
	 */
	public static List<List<String>> getNames(IDependency[] iDependencies) {
		if (iDependencies == null) return new ArrayList<List<String>>();

		List<List<String>> names = new ArrayList<List<String>>();
		for (int i = 0; i < iDependencies.length; i++) {
			IDependency dependency = iDependencies[i];
			List<String> m = new ArrayList<String>();
			m.add(dependency.getName());
			m.add(dependency.getClient().getName());
			m.add(dependency.getSupplier().getName());
			names.add(m);
		}
		return names;
	}

	/**
	 * ^Ol}bvƂĎ擾܂B
	 * 
	 * @param taggedValues
	 * @return ^Ol̃}bv
	 */
	public static Map<String, String> getTaggedValuesMap(ITaggedValue[] taggedValues) {
		if (taggedValues == null) return new HashMap<String, String>();

		Map<String, String> m = new HashMap<String, String>();
		for (int i = 0; i < taggedValues.length; i++) {
			ITaggedValue value = taggedValues[i];
			m.put(value.getKey(), value.getValue());
		}
		return m;
	}

	/**
	 * 𕶎Ŏ擾܂B
	 * 
	 * @param iNamedElement
	 *            Otvf
	 * @return 
	 */
	public static String getVisibility(INamedElement iNamedElement) {
		if (iNamedElement == null) return "";

		if (iNamedElement.isPackageVisibility()) {
			return "package";
		} else if (iNamedElement.isProtectedVisibility()) {
			return "protected";
		} else if (iNamedElement.isPrivateVisibility()) {
			return "private";
		} else if (iNamedElement.isPublicVisibility()) {
			return "public";
		}
		return "";
	}

	/**
	 * hLgRg̐擪̐𒲐ĕԂ܂B
	 * @param definition hLgRg
	 * @return ̃hLgRg̕
	 */
	public static String getDocumentCommentFormatDefinition(String definition) {
		return getDocumentCommentFormatDefinition(definition, "");
	}

	/**
	 * hLgRg̐擪̐w肳ꂽCfg̈ʒuɗ悤ɒĕԂ܂B
	 * @param definition hLgRg
	 * @param indent Cfg̋󔒕
	 * @return ̃hLgRg̕
	 */
	public static String getDocumentCommentFormatDefinition(String definition,
			String indent) {
		return definition.replaceAll("\n", "\n" + indent + " * ");
	}

	/**
	 * ֘Aɑ΂鑮̖ÕXg擾܂B
	 * @param association ֘A
	 * @return ֘Aɑ΂鑮̖ÕXg
	 */
	public static List<String> getAttributeNameList(IAssociation association) {
		if (association == null) return new ArrayList<String>();

		List<String> list = new ArrayList<String>();
		IAttribute[] attributes = association.getAttributes();
		for (int i = 0; i < attributes.length; i++) {
			list.add(attributes[i].getName());
		}
		return list;
	}

	/**
	 * dx1傫ǂ𔻒肵܂B
	 * 
	 * @param attribute
	 *            
	 * @return dx1傫̂ꍇtrueAȂꍇfalse߂B
	 */
	public static boolean isMultiplicity(IAttribute attribute) {
		for (IMultiplicityRange multiplicity : attribute.getMultiplicity()) {
			if (multiplicity.getUpper() == IMultiplicityRange.UNLIMITED
					|| multiplicity.getLower() > 1
					|| multiplicity.getUpper() > 1) {
				return true;
			}
		}
		return false;
	}

	/**
	 * w肳ꂽfobO[ĥƂɕWo͂ɏo͂܂B
	 * @param string 
	 */
	public static void println(String string) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		System.out.println(string);
	}

	/**
	 * NX̏\܂B
	 * 
	 * @param iClass NX
	 */
	public static void print(IClass iClass) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (iClass == null) return;

		
		String name = iClass.getName();
		print(iClass, name);
		System.out.println(name + ".abstract             = "
				+ iClass.isAbstract());
		System.out.println(name + ".active               = "
				+ iClass.isActive());
		System.out.println(name + ".leaf                 = " + iClass.isLeaf());
		System.out.println(name + ".attributes           = "
				+ JudeApi2CppUtil.getNames(iClass.getAttributes()) + ", size = " + iClass.getAttributes().length);
		System.out.println(name + ".operations           = "
				+ JudeApi2CppUtil.getNames(iClass.getOperations()) + ", size = " + iClass.getOperations().length);
		System.out.println(name + ".nestedClasses        = "
				+ Arrays.asList(iClass.getNestedClasses()) + ", size = " + iClass.getNestedClasses().length);
		System.out.println(name + ".generalizations      = "
				+ JudeApi2CppUtil.getNames(iClass.getGeneralizations()) + ", size = " + iClass.getGeneralizations().length);
		print(iClass.getGeneralizations());

		System.out.println(name + ".specializations      = "
				+ JudeApi2CppUtil.getNames(iClass.getSpecializations()) + ", size = " + iClass.getSpecializations().length);
		System.out.println(name + ".supplierRealizations = "
				+ JudeApi2CppUtil.getNames(iClass.getSupplierRealizations()) + ", size = " + iClass.getSupplierRealizations().length);
		System.out.println(name + ".clientRealizations   = "
				+ JudeApi2CppUtil.getNames(iClass.getClientRealizations()) + ", size = " + iClass.getClientRealizations().length);
		System.out.println(name + ".fullName             = "
				+ JudeApi2CppUtil.getFullName(iClass));
		System.out.println("--------");

		print(iClass.getAttributes());
		System.out.println("--------");

		print(iClass.getOperations());
	}

	/**
	 * ĉ̏\܂B
	 * @param generalizations ĉ
	 */
	public static void print(IGeneralization[] generalizations) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (generalizations == null) return;

		for (int i = 0; i < generalizations.length; i++) {
			IGeneralization generalization = generalizations[i];

			String type = "  "
					+ generalization.getName();
			print((INamedElement) generalization, type);

			System.out.println(type + ".subType              = "
					+ generalization.getSubType().getName());
			System.out.println(type + ".superType            = "
					+ generalization.getSuperType().getName());
			System.out.println("  ----");
		}
	}

	/**
	 * ̏\܂B
	 * 
	 * @param iAttributes 
	 */
	public static void print(IAttribute[] iAttributes) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (iAttributes == null) return;

		for (int i = 0; i < iAttributes.length; i++) {
			IAttribute attribute = iAttributes[i];
			if (attribute.getName().length() == 0)
				continue;
			String type = "  "
					+ ((INamedElement) attribute.getOwner()).getName() + "."
					+ attribute.getName();
			print((INamedElement) attribute, type);
			// System.out.println(type + ".type = " +
			// attribute.getType().getName());
			System.out.println(type + ".typeExpression       = "
					+ attribute.getTypeExpression());
			System.out.println(type + ".initialValue         = "
					+ attribute.getInitialValue());
			System.out.println(type + ".changeable           = "
					+ attribute.isChangeable());
			System.out.println(type
					+ ".association          = "
					+ ((attribute.getAssociation() != null) ? attribute
							.getAssociation().getName() : "NONE"));
			print(attribute.getAssociation());
			System.out.println(type + ".qualifiers           = "
					+ Arrays.asList(attribute.getQualifiers()) + ", size = " + attribute.getQualifiers().length);
			System.out.println(type
					+ ".multiplicity         = "
					+ JudeApi2CppUtil.getMultiplicity(attribute
							.getMultiplicity()));
			System.out.println(type + ".derived              = "
					+ attribute.isDerived());
			System.out.println(type + ".composite            = "
					+ attribute.isComposite());
			System.out.println(type + ".aggregate            = "
					+ attribute.isAggregate());
			System.out.println(type + ".enable               = "
					+ attribute.isEnable());
			System.out.println(type + ".static               = "
					+ attribute.isStatic());
			System.out.println("  ----");
		}
	}

	/**
	 * ֘A\܂B
	 * @param association ֘A
	 */
	public static void print(IAssociation association) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (association == null) return;
		
		String type = "    " + association.getName();
		print((INamedElement) association, association.getName(), "    ");
		System.out.println(type + ".attributes           = " + getAttributeNameList(association) + ", size = " + association.getAttributes().length);
		System.out.println("  ----");
	}

	/**
	 * \܂B
	 * 
	 * @param iOperations 
	 */
	public static void print(IOperation[] iOperations) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (iOperations == null) return;

		for (int i = 0; i < iOperations.length; i++) {
			IOperation operation = iOperations[i];
			if (operation.getName().length() == 0)
				continue;
			String type = "  "
					+ ((INamedElement) operation.getOwner()).getName() + "."
					+ operation.getName() + "()";
			print((INamedElement) operation, type);
			System.out.println(type
					+ ".parameters           = "
					+ JudeApi2CppUtil.getParameterList(operation
							.getParameters()) + ", size = " + operation.getParameters().length);
			// System.out.println(type + ".returnType = " +
			// operation.getReturnType().getName());
			System.out.println(type + ".returnTypeExpression = "
					+ operation.getReturnTypeExpression());
			System.out.println(type + ".leaf                 = "
					+ operation.isLeaf());
			System.out.println(type + ".abstract             = "
					+ operation.isAbstract());
			System.out.println(type + ".static               = "
					+ operation.isStatic());
			System.out.println("  ----");
		}
	}

	/**
	 * Otvf\܂B
	 * 
	 * @param iNamedElement Otvf
	 * @param name O
	 */
	public static void print(INamedElement iNamedElement, String name) {
		print(iNamedElement, name, "");
	}

	/**
	 * Otvf\܂B
	 * 
	 * @param iNamedElement Otvf
	 * @param name O
	 * @param indent Cfg̋󔒕
	 */
	public static void print(INamedElement iNamedElement, String name, String indent) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (iNamedElement == null) return;

		System.out.println(indent + name + ".name                 = "
				+ iNamedElement.getName());
		System.out.println(indent + name + ".id                   = "
				+ iNamedElement.getId());
		System.out.println(indent + name + ".constraints          = "
				+ JudeApi2CppUtil.getNames(iNamedElement.getConstraints()) + ", size = " + iNamedElement.getConstraints().length);
		System.out.println(indent + name
				+ ".supplierDependencies = "
				+ JudeApi2CppUtil.getNames(iNamedElement
						.getSupplierDependencies()) + ", size = " + iNamedElement.getSupplierDependencies().length);
		System.out.println(indent + name
				+ ".clientDependencies   = "
				+ JudeApi2CppUtil.getNames(iNamedElement
						.getClientDependencies()) + ", size = " + iNamedElement.getClientDependencies().length);
		System.out.println(indent + name + ".definition           = "
				+ iNamedElement.getDefinition());
		if (!(iNamedElement instanceof IModel))
			System.out.println(indent + name + ".visibility           = "
					+ JudeApi2CppUtil.getVisibility(iNamedElement));
		print((IElement) iNamedElement, name, indent);
	}

	/**
	 * vf\܂B
	 * 
	 * @param iElement vf
	 * @param name O
	 */
	public static void print(IElement iElement, String name) {
		print(iElement, name, "");
	}

	/**
	 * vf\܂B
	 * 
	 * @param iElement vf
	 * @param name O
	 * @param indent Cfg̋󔒕
	 */
	public static void print(IElement iElement, String name, String indent) {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		if (iElement == null) return;

		if (!(iElement instanceof IModel))
			System.out.println(indent + name + ".owner                = "
					+ ((INamedElement) iElement.getOwner()).getName());
		System.out.println(indent + name + ".comments             = "
				+ Arrays.asList(iElement.getComments()) + ", size = " + iElement.getComments().length);
		System.out.println(indent + name + ".stereotypes          = "
				+ Arrays.asList(iElement.getStereotypes()) + ", size = " + iElement.getStereotypes().length);
		System.out.println(indent + name
				+ ".taggedValues         = "
				+ JudeApi2CppUtil.getTaggedValuesMap(iElement.getTaggedValues()) + ", size = " + iElement.getTaggedValues().length);
	}

	/**
	 * ̃VXe̎vpeBׂĕWo͂ɏo͂܂B
	 */
	public static void printProperties() {
		if (!JudeApi2CppProperty.getInstance().isDebug()) return;
		JudeApi2CppProperty.getInstance().print();
	}
	
	/**
	 * w肳ꂽfBNgɂ邷ׂẴt@C폜܂B
	 * @param directory fBNg
	 */
	public static void deleteFiles(File directory) {
		if (directory == null || !directory.isDirectory()) return;
		
		for (File file : directory.listFiles()) {
			file.delete();
		}
	}

	/**
	 * w肳ꂽt@C폜܂B̂ƂAvpeB̒lɂāA폜邩ǂ₢킹܂B
	 * @param file
	 */
	public static boolean delete(File file) {
		if (JudeApi2CppProperty.getInstance().isGuiApplication()) {
			return JudeApi2CppGuiUtil.delete(file);
			
			
		} else {
//			return JudeApi2CppCuiUtil.delete(file);
		}
		
		return false;
	}

	/**
	 * 擾B`ĂȂꍇ́Â܂܂̖OԂB
	 * @param element Otvf
	 * @return 
	 * @since 3.0
	 */
	public static String getName(INamedElement element) {
		
		if (!hasPhisicalName(element)) {
			return element.getName();
		}
		
		String name;
		String definition = element.getDefinition();
		int index = definition.indexOf(PHISICAL_NAME);
		String[] tokens = definition.substring(index).split("[ \n]");
		try {
			name = tokens[1];
		} catch (RuntimeException e) {
			name = element.getName();
		}
		
		return name;
	}

	/**
	 * 邩ǂ𔻒fB
	 * @param element Otvf
	 * @return `Ătrue
	 * @since 3.0
	 */
	public static boolean hasPhisicalName(INamedElement element) {
		if (!JudeApi2CppProperty.getInstance().isUsePhisicalName()) {
			return false;
		}
		
		return element.getDefinition().indexOf(PHISICAL_NAME) >= 0;
	}
	
	/**
	 * `sɁAIWi̖Oǉu`v擾B
	 * @param element Otvf
	 * @return `sɁAIWi̖Oǉu`v
	 * @since 3.0
	 */
	public static String getDefinitionWithOriginalName(INamedElement element) {
		String definition = element.getDefinition();

		if (!JudeApi2CppProperty.getInstance().isUsePhisicalName()) {
			return definition;
		}
		
		if (!hasPhisicalName(element)) {
			return definition;
		}
		
		definition = new StringBuilder(definition).insert(definition.indexOf(PHISICAL_NAME) + PHISICAL_NAME.length() + 1, element.getName() + " ").toString();
		
		return definition;
		
	}

	/**
	 * w肳ꂽ삪p[^[̏W擾B
	 * @param operation 
	 * @return w肳ꂽ삪p[^[̏W
	 * @since 3.0
	 */
	public static String[] getParameterNames(IOperation operation) {
		String[] parameterNames = new String[operation.getParameters().length];
		
		for (int i = 0; i < parameterNames.length; i++) {
			IParameter parameter = operation.getParameters()[i];
			
			String name;
			String definition = operation.getDefinition();
			int index = definition.indexOf("@phisical-parameter-name");
			if (!JudeApi2CppProperty.getInstance().isUsePhisicalName() || index < 0) {
				name = parameter.getName();
			} else {
				String[] tokens = definition.substring(index).split("[ \n]");
				try {
					name = tokens[i + 1];
				} catch (RuntimeException e) {
					name = parameter.getName();
				}
			}
			
			parameterNames[i] = name;
			
		}
		return parameterNames;
	}

	/**
	 * @param attribute
	 * @return
	 * @since 3.0
	 */
	public static  String getTypeExpression(IAttribute attribute) {
		StringBuilder typeExpression = new StringBuilder(attribute.getTypeExpression());

		// TODO 2z̏ꍇǂ邩
		if (typeExpression.indexOf("[") >= 0) {
			typeExpression.replace(typeExpression.indexOf("["), typeExpression.indexOf("]") + 1, "*");
		}
		
		// ɒu
		if (hasPhisicalName(attribute.getType())) {
			typeExpression.replace(typeExpression.indexOf(attribute.getType().getName()), attribute.getType().getName().length(), getName(attribute.getType()));
		}

		// ^CvCq
		if (attribute.getTypeModifier() != null && !attribute.getTypeModifier().equals("*")) {
			typeExpression.append(attribute.getTypeModifier());
		}
		
		return typeExpression.toString();
	}

	/**
	 * @param operation
	 * @return
	 * @since 3.0
	 */
	public static  String getReturnTypeExpression(IOperation operation) {
		
		StringBuilder typeExpression = new StringBuilder(operation.getReturnTypeExpression());
		
		// ɒu
		if (hasPhisicalName(operation.getReturnType())) {
			typeExpression.replace(typeExpression.indexOf(operation.getReturnType().getName()), operation.getReturnType().getName().length(), getName(operation.getReturnType()));
		}

		return typeExpression.toString();
	}

	/**
	 * @param parameter
	 * @return
	 * @since 3.0
	 */
	public static  String getTypeExpression(IParameter parameter) {
		StringBuilder typeExpression = new StringBuilder(parameter.getTypeExpression());
		
		// ɒu
		if (hasPhisicalName(parameter.getType())) {
			typeExpression.replace(typeExpression.indexOf(parameter.getType().getName()), parameter.getType().getName().length(), getName(parameter.getType()));
		}

		return typeExpression.toString();
	}
	
	/**
	 * @param attribute
	 * @return
	 * @since 3.0
	 */
	public static String getSigneture(IAttribute attribute) {
		StringBuilder signeture = new StringBuilder();

		if (isArrayType(attribute)) {
			signeture.append(getName(attribute.getType()));
			
		} else {
			signeture.append(getTypeExpression(attribute));
		}
		
//		// TODO dxƂ̂
//		// ^CvCq
//		if (attribute.getTypeModifier() != null) {
//			signeture.append(attribute.getTypeModifier().toString());
//			
//		}
		
		
//		// dx
//		if (JudeApi2CppUtil.isMultiplicity(attribute)) {
//			signeture.append("*");
//		}

		signeture.append(" ");
		signeture.append(getName(attribute));
		
		// ɒu
		if (hasPhisicalName(attribute.getType())) {
			try {
				signeture.replace(signeture.indexOf(attribute.getType().getName()), attribute.getType().getName().length(), getName(attribute.getType()));
			} catch (RuntimeException e) {
				// sȂ
			}
		}

		// z錾ϐ̌ɂčs
		if (isArrayType(attribute)) {
			signeture.append(attribute.getTypeModifier());
			
		}
		
		return signeture.toString();
	}

	/**
	 * @param attribute
	 * @return
	 * @since 3.0
	 */
	public static boolean isArrayType(IAttribute attribute) {
		return (attribute.getTypeExpression().indexOf("[") >= 0) || (attribute.getTypeModifier().indexOf("[") >= 0);
	}

	public static String parseCsvTokenFormat(String string) {
		
		return "\"" + string.replaceAll("\"", "\"\"") + "\"";
	}

	public static String getUpperCaseName(IAttribute attribute) {
		String name = (getName(attribute).length() != 0 ?  getName(attribute) : getName(attribute.getAssociation()));
		if (name.length() == 0) {
			return "";
		}
		return name.substring(0, 1).toUpperCase() + (name.length() > 1 ? name.substring(1) : "");
	}

	public static void printElementComment(PrintWriter out, String indent,
			INamedElement element) {
		
		if (element.getDefinition() == null || element.getDefinition().length() == 0) return;
		
		out.println();
		out.println(indent + "/**");
		out.println(indent
				+ " * "
				+ JudeApi2CppUtil.getDocumentCommentFormatDefinition(
						getDefinitionWithOriginalName(element), indent));
		out.println(indent + " */");
	}

	/**
	 * @param out
	 * @param indent
	 * @param definition
	 * @since 3.0
	 */
	public static void printElementComment(PrintWriter out, String indent,
			String definition) {
		
		out.println();
		out.println(indent + "/**");
		out.println(indent
				+ " * "
				+ JudeApi2CppUtil.getDocumentCommentFormatDefinition(
						definition, indent));
		out.println(indent + " */");
	}


	/**
	 * 킷擾܂B ́A3̂̂ꂩɁA킷 public, protected,
	 * private ƂłB ̕ȂꍇẢ public Ƃ܂B
	 * <p>
	 * <ul>
	 * <li>^OlƂ{ = true} 
	 * <li>XeI^Cv  
	 * <li>  
	 * </ul>
	 * </p>
	 * 
	 * @param element
	 *            Ovf
	 * @return 킷
	 */
	public static String getVisibilityString(INamedElement element) {

		if (hasConstraint("protected", element)
				|| hasTaggedValue("protected", "true", element)
				|| hasStereotype("protected", element)) {
			return "protected";
		} else if (hasConstraint("private", element)
				|| hasTaggedValue("private", "true", element)
				|| hasStereotype("private", element)) {
			return "private";
		}

		return "public";
	}

	/**
	 * 삪Aconstł邩ǂ𔻒肵܂Bconstǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{const = true} 
	 * <li>XeI^Cv const 
	 * <li> const 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAconstantCqtrueB
	 */
	public static boolean isConst(IOperation operation) {
		return hasConstraint("const", operation)
				|| hasTaggedValue("const", "true", operation)
				|| hasStereotype("const", operation);
	}

	/**
	 * 삪Aexplicitł邩ǂ𔻒肵܂Bexplicitǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{explicit = true} 
	 * <li>XeI^Cv explicit 
	 * <li> explicit 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAexplicitCqtrueB
	 */
	public static boolean isExplicit(IOperation operation) {
		return hasConstraint("explicit", operation)
				|| hasTaggedValue("explicit", "true", operation)
				|| hasStereotype("explicit", operation);
	}

	/**
	 * 삪Ainlineł邩ǂ𔻒肵܂Binlineǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{inline = true} 
	 * <li>XeI^Cv inline 
	 * <li> inline 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAinlineCqtrueB
	 */
	public static boolean isInline(IOperation operation) {
		return hasConstraint("inline", operation)
				|| hasTaggedValue("inline", "true", operation)
				|| hasStereotype("inline", operation);
	}

	/**
	 * 삪Afriendł邩ǂ𔻒肵܂Bfriendǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{friend = true} 
	 * <li>XeI^Cv friend 
	 * <li> friend 
	 * </ul>
	 * </p>
	 * 
	 * @param operation
	 *            
	 * @return ̐錾ɁAfriendCqtrueB
	 */
	public static boolean isFriend(IOperation operation) {
		return hasConstraint("friend", operation)
				|| hasTaggedValue("friend", "true", operation)
				|| hasStereotype("friend", operation);
	}

	/**
	 * OvfAvirtualł邩ǂ𔻒肵܂Bvirtualǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{virtual = true} 
	 * <li>XeI^Cv virtual 
	 * <li> virtual 
	 * </ul>
	 * </p>
	 * 
	 * @param element
	 *            
	 * @return vfAvirtualłtrueB
	 */
	public static boolean isVirtual(INamedElement element) {
		return hasConstraint("virtual", element)
				|| hasTaggedValue("virtual", "true", element)
				|| hasStereotype("virtual", element);
	}

	/**
	 * 삪Amutableł邩ǂ𔻒肵܂Bmutableǂ́A3̂̂ꂩ藧ƂłB
	 * <p>
	 * <ul>
	 * <li>^OlƂ{mutable = true} 
	 * <li>XeI^Cv mutable 
	 * <li> mutable 
	 * </ul>
	 * </p>
	 * 
	 * @param attribute
	 *            
	 * @return 삪AmutablełtrueB
	 */
	public static boolean isMutable(IAttribute attribute) {
		return hasConstraint("mutable", attribute)
				|| hasTaggedValue("mutable", "true", attribute)
				|| hasStereotype("mutable", attribute);
	}

	/**
	 * ɁAw肳ꂽ񂪂邩ǂ𔻒肵܂B
	 * 
	 * @param keyword
	 *            
	 * @param element
	 *            
	 * @return ɁAw肳ꂽ񂪂trueB
	 */
	public static boolean hasConstraint(String keyword, INamedElement element) {
		for (IConstraint constraint : element.getConstraints()) {
			if (constraint.getName().equals(keyword)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * ^OlɁAw肳ꂽ^Ol邩ǂ𔻒肵܂B
	 * 
	 * @param keyword
	 *            ^ÕL[
	 * @param value
	 *            ^O̒l
	 * @param element
	 *            vf
	 * @return ^OlɁAw肳ꂽ^OltrueB
	 */
	public static boolean hasTaggedValue(String keyword, String value,
			IElement element) {
		for (ITaggedValue taggedValue : element.getTaggedValues()) {
			if (taggedValue.getKey().equals(keyword)
					&& taggedValue.getValue().equals(value)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * XeI^CvɁAw肳ꂽ񂪂邩ǂ𔻒肵܂B
	 * 
	 * @param keyword
	 *            
	 * @param element
	 *            vf
	 * @return vfɁAw肳ꂽ񂪂trueB
	 */
	public static boolean hasStereotype(String keyword, IElement element) {
		for (String stereotype : element.getStereotypes()) {
			if (stereotype.equals(keyword)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * w肳ꂽNXAO^ǂ𔻒肵܂B
	 * 
	 * @param element
	 *            NX^
	 * @return O^Ȃtrue
	 */
	public static boolean isExcepted(IClass element) {
		return !JudeApi2CppProperty.getInstance().getExceptTypes()
				.contains(element.getName());
	}


}
