package jp.marunomaruno.judeapi2cpp.gui;

import java.awt.GridLayout;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import jp.marunomaruno.judeapi2cpp.JudeApi2CppProperty;

/**
 * ̃vÕCEBhE`NXłB
 * @author  maruno
 * @version 1.0, 2007-12-20
 * @since   1.0
 */
@SuppressWarnings("serial")
public class JudeApi2CppFrame extends JFrame {
	private JPanel sourcePanel; 
	private JLabel sourceLabel;
	private JTextField sourceField;

	private JPanel destinationPanel; 
	private JLabel destinationLabel;
	private JTextField destinationField;
	
	private JPanel makefilePanel; 
	private JLabel makefileLabel;
	private JTextField makefileField;
	
	private JPanel targetPanel; 
	private JLabel targetLabel;
	private JTextField targetField;
	
	private JPanel executingPanel;
	private JButton executeButton;
	private JCheckBox forceReplaceFileCheckBox;
	private JCheckBox setterCheckBox;
	private JCheckBox getterCheckBox;
	private JCheckBox constractorCheckBox;
	private JCheckBox phisicalNameCheckBox;
	private JPanel accesserPanel;
	
	/**
	 * RXgN^[łB
	 */
	public JudeApi2CppFrame() {
		// ԃRei̐Ɛݒ
		accesserPanel = new JPanel();
		executingPanel = new JPanel();
		
		// JUDEt@C̎w
		sourceLabel = new JLabel("JUDEt@C: ");
		sourceField = new JTextField(JudeApi2CppProperty.getInstance().getSourceFile());
		sourcePanel = new FileChooserPanel(sourceLabel, sourceField, new SourceFileChooser(sourceField));
		
		// CPPt@C̊i[
		destinationLabel = new JLabel("CPPfBNg: ");
		destinationField = new JTextField(JudeApi2CppProperty.getInstance().getDestinationDirectory());
		destinationPanel = new FileChooserPanel(destinationLabel, destinationField, new DestinationDirectoryChooser(destinationField));

		// ^[Qbg̎w
		targetLabel = new JLabel("^[Qbg: ");
		String target = JudeApi2CppProperty.getInstance().getTarget();
		if (target.equals("")) {
			target = new File(sourceField.getText()).getName();
			target = target.substring(0, Math.max(target.length()-5, 0));
		}
		targetField = new JTextField(target);
		targetPanel = new FileChooserPanel(targetLabel, targetField, null);

		// makefileXPg̎w
		makefileLabel = new JLabel("makefileXPg: ");
		makefileField = new JTextField(JudeApi2CppProperty.getInstance().getMakefileSekeleton());
		makefilePanel = new FileChooserPanel(makefileLabel, makefileField, new MakefileSekeletonChooser(makefileField));

		// ANZbT[E`FbN{bNX
		setterCheckBox = new JCheckBox("Zb^[  ", JudeApi2CppProperty.getInstance().isCreateSetter());
		getterCheckBox = new JCheckBox("Qb^[  ", JudeApi2CppProperty.getInstance().isCreateGetter());
		constractorCheckBox = new JCheckBox("RXgN^[  ", JudeApi2CppProperty.getInstance().isCreateConstractor());
		accesserPanel.add(setterCheckBox);
		accesserPanel.add(getterCheckBox);
		accesserPanel.add(constractorCheckBox);
		
		// t@C̋u`FbN{bNX
		forceReplaceFileCheckBox = new JCheckBox("t@C̋u  ", JudeApi2CppProperty.getInstance().isForceReplaceFile());
			
		// gp`FbN{bNX
		phisicalNameCheckBox = new JCheckBox("gp  ", JudeApi2CppProperty.getInstance().isUsePhisicalName());
			
		// s{^
		executeButton = new JButton("s");
		executeButton.addActionListener(new TransformCommand(sourceField, destinationField, targetField, forceReplaceFileCheckBox, setterCheckBox, getterCheckBox, constractorCheckBox, phisicalNameCheckBox));
		executingPanel.add(forceReplaceFileCheckBox);
		executingPanel.add(phisicalNameCheckBox);
		executingPanel.add(executeButton);
		
		// ԃReit[֒ǉ
		add(sourcePanel);
		add(destinationPanel);
		add(targetPanel);
		add(makefilePanel);
		add(accesserPanel);
		add(executingPanel);
		
		// t[̐ݒ
		setTitle("JudeApi2Cpp");
		setLayout(new GridLayout(0, 1));
		if (JudeApi2CppProperty.getInstance().isAutoShutdown()) {
			setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		} else {
			setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
			addWindowListener(new JudeApi2CppWindowListener());
		}

		pack();
		setLocationByPlatform(true);
	}

}
